<?php
namespace Drupal\templating;

use Drupal\Core\Url;
use Drupal\Core\Render\Markup;

class EntityInlineTemplate extends BaseServiceEntityInlineTemplate
{


     /**
      *  template.[ENTITY_NAME].[THEME].[BUNDLE].[MODE_VIEW]
     **/
     function getTemplateBlock($variables){
         $plugin_id = trim($variables['elements']['#plugin_id']);
         $base_plugin_id = trim($variables['elements']['#base_plugin_id']);
         $theme = $this->is_allowed();
         if(!$theme){
             return false;
         }
         $suggestion_1 = $this->formatName('template.block--'.$theme.'-'.$plugin_id.'.html.twig');
         $suggestion_2 = $this->formatName('template.block--'.$theme.'-'.$base_plugin_id.'.html.twig');
         $output = false ;
         $config = \Drupal::config($suggestion_2) ;
         $config_id = \Drupal::config($suggestion_1) ;
         if($config_id && $config_id->get('content')){
             $config = $config_id;
         }
         if($config && $config->get('content') &&
             $config->get('status')
         ){
             $output =  $config->get('content');
         }
         return $output ;
     }


    function getTemplateBlockContent($variables){
        $config = null; 

        $theme = $this->is_allowed();
        if(!$theme){
            return false;
        }
        $enabled_themes = \Drupal::service('theme_handler')->listInfo();
        $themebase = \Drupal::service('theme_handler')->getBaseThemes($enabled_themes, $theme );
        $base = null; 
        if(!empty($themebase)){
            $base = array_keys($themebase)[0] ;
        }
         $content_block = isset($variables['content']['#block_content']) ? $variables['content']['#block_content'] : $variables['content']['content']['#block_content'];
         $mode_view = isset($variables['content']['#view_mode'])? $variables['content']['#view_mode'] : $variables['content']['content']['#view_mode'];
         $bundle = $content_block->bundle();
         $id = $content_block->id();
         $suggestion = $this->formatName('template.block--'.$theme.'-'.$bundle."-".$mode_view.".html.twig");
         $suggestion_id = $this->formatName('template.block--'.$theme.'-'.$bundle."-".$mode_view."-".$id.".html.twig");
         $output = false ;
         $config_current = \Drupal::config($suggestion) ;
         $config_id = \Drupal::config($suggestion_id) ;
         // base theme 
         if($base){
            $suggestionbase = $this->formatName('template.block--'.$base.'-'.$bundle."-".$mode_view.".html.twig");
            $config_id_base = \Drupal::config($suggestionbase) ;
            if($config_id_base && $config_id_base->get('content') && 
            $config_id_base->get('status')){
               $config = $config_id_base;
            }
         }
         // current theme
         if($config_current && $config_current->get('content')){
            $config = $config_current;
          }

         // current theme by id
         if($config_id && $config_id->get('content')){
             $config = $config_id;
         }
         
         //database hook 
   
         
         

         if($config && $config->get('content') &&
             $config->get('status')
         ){
            
             $output =  $config->get('content');
             $output = $this->injectionSpacer($output) ;
             $output = $this->assetInjection($output,$config) ;
         }
         return $output ;
     }
  



    function getTemplateEntity($entity,$view_mode){
        $output = $this->getTemplatingDatabase($entity,$view_mode);
        if ($entity->isPublished() && $output) {
           return  $output ;
        }
        return false ;
    }
    function getTemplatingDatabase($entity,$mode_view){
        $theme = $this->is_allowed();
        if(!$theme){
            return false;
        }
        $entity_name  = $entity->getEntityTypeId();
        $bundle = $entity->bundle();
        $id = $entity->id();         
        $output = false ;
        $hook_name = $entity_name.'--'.$theme.'-'.$bundle."-".$mode_view.".html.twig" ;

        $content = $this->getTemplatingByTitle($hook_name);
        if(!is_object($content)){
           $hook_name_base = $entity_name.'--'.$theme.'-'.$bundle."-".$mode_view.".html.twig" ;
           $content_base = $this->getTemplatingByTitle($hook_name_base);
           if(is_object($content_base)){
               $content = $content_base;
           }
        }
        $hook_name_id = $entity_name.'--'.$theme.'-'.$bundle."-".$mode_view."-".$id.".html.twig" ;
        $content_id = $this->getTemplatingByTitle($hook_name_id);
        if(is_object($content_id)){
           $content = $content_id ;
        }
        if(is_object($content)){
           $output = $content->field_templating_html->value ;
        }
        return $output ;
       
    } 





}